﻿Imports System.Text
Imports System.Threading.Tasks

Imports System.Console
Imports System.Net.Http
Imports System.Net.Http.Headers

Namespace converToPDF_consumer
	Friend Class Program
		Shared Sub Main(ByVal args() As String)
			Dim message As String = "www.bing.com"
			Dim convertMessage As String = "no message yet"

            'message is the URL to be converted -> www.bing.com
            Task.Run(Async Sub() convertMessage = Await ConvertToPDFWebJobAPIAsync(message)).Wait()

            WriteLine($"{convertMessage}")
			ReadLine()
		End Sub

		Private Shared async Function ConvertToPDFWebJobAPIAsync(ByVal Url As String) As Task(Of String)
			'PDF file is saved in D:\local\temp\jobs\triggered\convertToPDF\*****\
			Try
                Using client = New HttpClient
                    client.BaseAddress = New Uri("https://your-app-name.scm.azurewebsites.net/")
                    client.DefaultRequestHeaders.Accept.Clear()

                    'username and password from Publish Profile, can test via https://your-app-name.scm.azurewebsites.net/basicAuth
                    Dim userName = "<add your userName"
                    Dim password = "<add your userPWD"

                    Dim encoding = New ASCIIEncoding
                    Dim authHeader = New AuthenticationHeaderValue("Basic", Convert.ToBase64String(encoding.GetBytes(String.Format($"{userName}:{password}"))))
                    client.DefaultRequestHeaders.Authorization = authHeader

                    Dim content = New System.Net.Http.StringContent("")
                    Dim filename As String = Guid.NewGuid().ToString("N").Substring(0, 8) & ".pdf"
                    Dim response As HttpResponseMessage = Await client.PostAsync($"api/triggeredwebjobs/convertToPDF/run?arguments={Url} {filename}", content)

                    If Not response.IsSuccessStatusCode Then
                        Return $"Conversion for {Url} {filename} failed: " & Date.Now.ToString()
                    End If

                    Return $"{response.StatusCode.ToString()}: your PDF can be downloaded from here: https://your-storage-account.blob.core.windows.net/your-storage-container/{filename}"
                End Using
            Catch ex As Exception
				Return ex.Message
			End Try
		End Function
	End Class
End Namespace
