﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports Microsoft.AspNet.SignalR
Imports System.Threading.Tasks
Imports System.Net.Http
Imports System.Net.Http.Headers
Imports System.Text

Namespace ConvertHTMLtoPDF
	Public Class ChatHub
		Inherits Hub
		Public Sub Send(ByVal name As String, ByVal message As String)
			'Task.Run(async () =>
			'{
			'    message = await ConvertToPDFWebJobAPIAsync(message);

			'}).Wait();

			' Call the broadcastMessage method to update clients.
			Clients.All.broadcastMessage(name, message)
		End Sub

		Private Shared async Function ConvertToPDFWebJobAPIAsync(ByVal Url As String) As Task(Of String)
			'PDF file is saved in D:\local\temp\jobs\triggered\convertToPDF\*****\
			Try
                Using client = New HttpClient
                    client.BaseAddress = New Uri("https://converthtmltopdf.scm.azurewebsites.net/")
                    client.DefaultRequestHeaders.Accept.Clear()

                    'username and password from Publish Profile, can test via https://converthtmltopdf.scm.azurewebsites.net/basicAuth
                    Dim userName = "$ConvertHTMLtoPDF"
                    Dim password = "4ryQPNWoteESQ0ljx3QxceYxbhNeYS7uC9jtYhod2Ekhp1mhRGGMpC0zggQn"

                    Dim encoding = New ASCIIEncoding
                    Dim authHeader = New AuthenticationHeaderValue("Basic", Convert.ToBase64String(encoding.GetBytes(String.Format($"{userName}:{password}"))))
                    client.DefaultRequestHeaders.Authorization = authHeader

                    Dim content = New System.Net.Http.StringContent("")
                    Dim filename As String = Guid.NewGuid().ToString("N").Substring(0, 8) & ".pdf"
                    Dim response As HttpResponseMessage = Await client.PostAsync($"api/triggeredwebjobs/convertToPDF/run?arguments={Url} {filename}", content)

                    If Not response.IsSuccessStatusCode Then
                        Return $"Conversion for {Url} {filename} failed: " & Date.Now.ToString()
                    End If

                    Return $"{response.StatusCode.ToString()}: your PDF can be downloaded from here: https://converthtmltopdf.blob.core.windows.net/pdf/{filename}"
                End Using
            Catch ex As Exception
				Return ex.Message
			End Try
		End Function


	End Class
End Namespace